#extension GL_OES_EGL_image_external : require
precision lowp float;

varying vec2 vTextureCoord;

uniform samplerExternalOES sTexture;
uniform sampler2D textureLUT;
float intensity = float(1.0);

void main()
{
    vec2 uv = vTextureCoord;
    vec4 color = texture2D(sTexture, uv);

    vec4 color2 = vec4(color.rgb * pow(2.0, -0.05), color.w);
    color2 = clamp(color2, 0., 1.);

    float blueColor = color2.b * 63.0;
    vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);
    vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);
    vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * color2.r);
    texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * color2.g);
    vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * color2.r);
    texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * color2.g);
    vec4 newColor1 = texture2D(textureLUT, texPos1);
    vec4 newColor2 = texture2D(textureLUT, texPos2);
    vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
    gl_FragColor = mix(color2, vec4(newColor.rgb, color2.a), intensity);

}